// I stole this from PMODE/W v1.22
// just to show you that sin() and WATCOM works

// Warning : Due to bugs in Watcom v10.6 this will not work, use BCC32 v4.5
//           or 5.0 instead and you'll need TASM32 v5.0 (just use BC2EXE.BAT)

/*****************************************************************************

  This is a simple example of some graphics functions in C. I got a bit bored
one day so I decided to make this little plasma. The original idea came from
Jare/VangeliSTeam's VTIRIS and was converted to C just for fun. This program
also makes use of floating point and inline ASM just to show that they do
indeed work under PMODE/W.

NOTE: There is a bug in wcc386.  You can not use parameters inside functions
  when using the asm{} blocks.

*****************************************************************************/

#include <qlib.h>
#include <string.h>
#include <math.h>
#include <video.h>
#include <conio.h>
#include <stdio.h>
#include <stdlib.h>

#define M_PI 3.141592654
#define SCALE 6
#define SPEED 2
#define FULL_SCREEN    //use 320x200 instead of the Tweaked 80x50 mode
#ifdef FULL_SCREEN
  #define X 320
  #define Y 200
#else
  #define X 80
  #define Y 50
#endif

#define spd1 1
#define spd2 2
#define spd3 1
#define spd4 3

#define idx1 1
#define idx2 2
#define idx3 1
#define idx4 3

// This function CAN NOT be compiled by Watcom due to BUGS!
// You can compile the asm {} block in Watcom because it is converted to the
// #pragma style by iASM pre-compiler (included in QLIB v2.00)
#ifdef __WATCOMC__
  #error Watcom can not compile this due to bug!
#endif

void vmode (word m) {
  asm {
    mov ax,m
    int 10h
  }
}

void waitvr (void) {
  //return;  //unrem this for some SPEED
  asm {
        mov dx,3dah
     wait1:
        in al,dx
        test al,8
        jnz wait1
     wait2:
        in al,dx
        test al,8
        jz wait2
      }
}

void tweakvga (void) {
 asm {
        mov dx,3c4h
        mov ax,604h
        out dx,ax
        mov ax,0f02h
        out dx,ax
        mov dx,3d4h
        mov ax,14h
        out dx,ax
        mov ax,0e317h
        out dx,ax
        mov al,9
        out dx,al
        inc dx
        in al,dx
        and al,0e0h
        add al,7
        out dx,al
  }
}

void main ()
{
  static byte wavetable[256], pal[768];

  dword  v, x, y;

  byte z;
  byte *vidmem = (byte *)0xa0000;

  byte pos1 = 0, pos2 = 0, pos3 = 0, pos4 = 0;
  byte tpos1, tpos2, tpos3, tpos4;
 
  if (!_fpu) {
    printf("No 80387 detected!\n");
    exit(0);
  }
  
  for (x=0;x<768;x++) pal[x]=0;

  for (x=0, y=0; x<64*3; x+=3, y++)
    pal[x+0] = y;

  for (x=64*3, y=63; x<128*3; x+=3, y--)
    pal[x+0] = y;

  for (x=128*3, y=0; x<192*3; x+=3, y++)
    pal[x+2] = y;

  for (x=192*3, y=63; x<256*3; x+=3, y--)
    pal[x+2] = y;

//asm int 3  //BUG!
  for (x=0; x<256; x++)
    wavetable[x] = 30 * (1.0 + sin(x*2 * M_PI / 256));

  vmode (0x13);
  #ifndef FULL_SCREEN
    tweakvga ();
  #endif
  g_setpal (&pal);

  while (!kbhit ())
  {
    waitvr ();

    v = 0;
    tpos1 = pos1;
    tpos2 = pos2;

    for (y=0; y<Y; y++)
    {
      tpos3 = pos3;
      tpos4 = pos4;

      for(x=0; x<X; x++)
      {
        z = wavetable[tpos1] + wavetable[tpos2] +
            wavetable[tpos3] + wavetable[tpos4];

        vidmem[v ++] = z;

        tpos3 += idx3*SCALE;
        tpos4 += idx4*SCALE;
      }

      tpos1 += idx1*SCALE;
      tpos2 += idx2*SCALE;
    }

    pos1 += spd1*SPEED;
    pos2 -= spd2*SPEED;
    pos3 += spd3*SPEED;
    pos4 -= spd4*SPEED;
  }

  getch ();
  vmode (3);
}

